$fn = 200;


//filament_holder();

//handle();

power_holder();

module power_holder(){
  width = 72;
  height = 41;
  a = 30;
  b = 15;
  wall = 2;
  
  cord_cut_w = 40;
  cord_cut_h = 25;
  
  M3_hole = 3.5;
  

  //upper half
  translate([0, height+5+ 2*wall, 0]){
    difference(){
      translate([38, (height+wall)/2, b/2]){
        rotate([90, 0, 0]){
          cylinder(d=b, h=wall, center=true);
        }
      }
      translate([width/2+7, (height+wall)/2, b/2]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=wall*1.1, center=true);
        }
      }
    }
    difference(){
      translate([-38, (height+wall)/2, b/2]){
        rotate([90, 0, 0]){
          cylinder(d=b, h=wall, center=true);
        }
      }
      translate([-width/2-7, (height+wall)/2, b/2]){
        rotate([90, 0, 0]){
          cylinder(d=M3_hole, h=wall*1.1, center=true);
        }
      }
    }
    translate([0, 0, b/2]){
      difference(){
        cube(size=[width+2*wall, height+2*wall, b], center=true);
        cube(size=[width, height, b*1.1], center=true);
      }
    }
  }
  
  //lower half
  difference(){
    translate([32, (height+wall)/2, a/2]){
      rotate([90, 0, 0]){
        cylinder(d=a, h=wall, center=true);
      }
    }
    translate([width/2+7, (height+wall)/2, a/2]){
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=wall*1.1, center=true);
      }
    }
  }
  difference(){
    translate([-32, (height+wall)/2, a/2]){
      rotate([90, 0, 0]){
        cylinder(d=a, h=wall, center=true);
      }
    }
    translate([-width/2-7, (height+wall)/2, a/2]){
      rotate([90, 0, 0]){
        cylinder(d=M3_hole, h=wall*1.1, center=true);
      }
    }
  }
  translate([0, 0, a/2]){
    difference(){
      cube(size=[width+2*wall, height+2*wall, a], center=true);
      translate([0, 0, wall]){
        cube(size=[width, height, a], center=true);
      }
      cube(size=[cord_cut_w, cord_cut_h, a*2], center=true);
    }
  }
}

module handle(){
  diameter = 30;
  length = 125;
  thickness = 5;
  cut = 5;
  height=120-diameter/2-(diameter-2*cut)/2;
  mount_distance = 30;
  
  difference(){
    translate([0, 0, diameter/2-cut]){
      rotate([0, 90, 0]){
        cylinder(d=diameter, h=length, center=true);
      }
    }
    translate([0, 0, -diameter/2]){
      cube(size=[length*1.1, diameter, diameter], center=true);
    }
    translate([0, 0, diameter/2+diameter-cut*2]){
      cube(size=[length*1.1, diameter, diameter], center=true);
    }
  }
  
  translate([(length-thickness)/2, height/2, diameter/2-cut]){
    difference(){
      union(){
        cube(size=[thickness, height, diameter-2*cut], center=true);
        translate([0, height/2, 0]){
          rotate([0, 90, 0]){
            cylinder(d=diameter-2*cut, h=thickness, center=true);
          }
        }
      }
      translate([0, height/2, 0]){
        rotate([0, 90, 0]){
          cylinder(d=3.5, h=thickness*1.1, center=true);
        }
      }      
      translate([0, height/2-mount_distance, 0]){
        rotate([0, 90, 0]){
          cylinder(d=3.5, h=thickness*1.1, center=true);
        }
      }      
    }
  }

  translate([-(length-thickness)/2, height/2, diameter/2-cut]){
    difference(){
      union(){
        cube(size=[thickness, height, diameter-2*cut], center=true);
        translate([0, height/2, 0]){
          rotate([0, 90, 0]){
            cylinder(d=diameter-2*cut, h=thickness, center=true);
          }
        }
      }
      translate([0, height/2, 0]){
        rotate([0, 90, 0]){
          cylinder(d=3.5, h=thickness*1.1, center=true);
        }
      }      
      translate([0, height/2-mount_distance, 0]){
        rotate([0, 90, 0]){
          cylinder(d=3.5, h=thickness*1.1, center=true);
        }
      }      
    }
  }
  
}

module filament_holder(){
  diameter = 35;
  length = 120;
  cut = 10;

  mount_w = 25;
  mount_thickness = 5;
  mount_l = 90;
  mount_hole = 3.5;

  hook_w = diameter-cut*2;
  hook_h = 1;
  hook_thickness = 5;

  //Main body
  difference(){
    translate([0, 0, diameter/2-cut]){
      rotate([0, 90, 0]){
        cylinder(d=diameter, h=length, center=true);
      }
    }
    translate([0, 0, -diameter/2]){
      cube(size=[length*1.1, diameter, diameter], center=true);
    }
  }

  //Mount
  translate([(length-mount_w)/2, 0, mount_thickness/2]){
    difference(){
      union(){
        cube(size=[mount_w, mount_l, mount_thickness], center=true);
        translate([0, mount_l/2, 0]){
          cylinder(d=mount_w, h=mount_thickness, center=true);
        }
        translate([0, -mount_l/2, 0]){
          cylinder(d=mount_w, h=mount_thickness, center=true);
        }
      }
      translate([0, mount_l/2, 0]){
        cylinder(d=mount_hole, h=mount_thickness*1.1, center=true);
      }
      translate([0, -mount_l/2, 0]){
        cylinder(d=mount_hole, h=mount_thickness*1.1, center=true);
      }
      
    }
  }

  //Hook
  translate([(hook_thickness-length)/2, hook_h/2+diameter/4, hook_w/2]){
    cube(size=[hook_thickness, hook_h+diameter/2, hook_w], center=true);
  }
  translate([(hook_thickness-length)/2, hook_h+diameter/2, hook_w/2]){
    rotate([0, 90, 0]){
      cylinder(d=hook_w, h=hook_thickness, center=true);
    }
  }
}
